Bug 55028 - Add Ability to Create Templates
Summary: Add Ability to Create Templates
Status: RESOLVED FIXED
Alias: None
Product: JMeter
Classification: Unclassified
Component: Main (show other bugs)
Version: 2.9
Hardware: All All
: P2 enhancement (vote)
Target Milestone: ---
Assignee: JMeter issues mailing list
URL:
Keywords:
Depends on: 55085
Blocks:
  Show dependency tree
 
Reported: 2013-05-29 16:54 UTC by oliver lloyd
Modified: 2013-07-09 13:24 UTC (History)
1 user (show)



Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description oliver lloyd 2013-05-29 16:54:53 UTC
It would be useful if there were an option to save the currently open testplan as a template that can be reused later as a time saving measure.

A template testplan might have the suffix .jmt (not .jmx) and live in a special folder such that, when jmeter is loaded, it reads this folder and populates a sub menu with available options.

Ie.:
File > Save As Template - would create a new template.
File > Open Template > - would show a sub menu of previously saved templates.


This would help individuals save and access their own custom templates but you could also have standard templates baked into jmeter to help reduce the steep learning curve for new users of JMeter. A standard web template (using dummy values) with obvious things like cookie management and assertions would very likely save a lot of people a lot of time.

Yes, baking in templates like this would be opinionated but hey, there really are some basic use cases where a template would work very well and it's also a superb way to give users quick and obvious access to feature examples.
Comment 1 Sebb 2013-05-29 16:58:57 UTC
In what way would a template be different from a test plan?

What's wrong with "Save As ..." ?
Comment 2 Philippe Mouawad 2013-06-03 20:06:30 UTC
I think Oliver idea is something like this maybe:
- Create a folder used for template in which we would put sample test plans like:
* Http Web Test plan
* Ldap Test Plan
* JDBC Test Plan

- We would have somewhere a Menu "create from templates", that would let use choose what kind of Test he wants to do and we would only open this

- Users could create new "model" plan (which would be a regular Test plan) and have an option to name this model (for example : HTTP with Basic Auth)


This would be useful for new users to JMeter as sometimes kickstart could be improved.

Oliver is this your idea ?
Comment 3 Philippe Mouawad 2013-06-03 20:07:12 UTC
I find this a very good idea for new users !
Comment 4 oliver lloyd 2013-06-03 20:19:28 UTC
Yes, exactly. Actually Phillipe's definition is even better as it includes both some standard kickstart templates for new users and also allows established users to save their own custom templates.

The more I think about this the more it feels right. It's true, you can use Save As but it's amazing how easy it is for a work flow like this to fail. All I have to do is forget to save my 'template' testplan using a new name and the process is broken, I have to re-create the template testplan again...

If there were a 'special' template type of testplan and if, when I opened it, I were not able to overwrite it, then suddenly my world becomes better, easier.
Comment 5 Sebb 2013-06-03 20:31:37 UTC
(In reply to oliver lloyd from comment #4)
> 
> If there were a 'special' template type of testplan and if, when I opened
> it, I were not able to overwrite it, then suddenly my world becomes better,
> easier.

Just mark it read-only.
Comment 6 oliver lloyd 2013-06-07 09:50:16 UTC
OK, so yes, it's true that it IS possible to get this functionality by using a process of save as and marking the file as read only. 

But you know, maybe this is the reason why JMeter is so hard for new users to learn. Just because it is possible to achieve something that's not a reason why we should not make it easier and more intuitive to do. UX is not exactly JMeter's strongest feature but why not try and improve that? Why not implement some enhancements to UX?
Comment 7 Sebb 2013-07-09 13:24:39 UTC
This has been fixed in 55085